Diskuzní fórum a databáze tipů a utilit pro AutoCAD, Inventor, Revit a další produkty Autodesk - od firmy CAD Studio [www.cadforum.cz]
Česky Slovensky English Deutsch
Přihlášení:
▶ Registrace

 právě nás čte: 6823 
RSS tipy RSS kanál - CAD tipy
RSS diskuze RSS kanál - CAD diskuze

Diskuze Diskuzní fórum, poradna

NápovědaCAD diskuze, rady, výměna zkušeností

CAD Fórum - Homepage Veřejné diskuzní fórum k CAD aplikacím - ptejte se na libovolné otázky týkající se oboru CAx, podělte se o vaše znalosti a zkušenosti s programy AutoCAD, Inventor, Revit, Fusion 360, 3ds Max a s dalšími CAD aplikacemi. Zaregistrujte se nebo se přihlašte a zašlete váš příspěvek do odpovídajícího fóra. Viz další informace o CAD Fóru. Nechcete se registrovat? Zeptejte se v naší Facebook poradně.
Fórum nenahrazuje technický support firmy CAD Studio - přímá podpora pro zákazníky funguje na helpdesk.cadstudio.cz
  FAQ FAQ  Prohledat fórum   Události   Registrovat Registrovat  Přihlásit Přihlásit

Vytvoření složitější polyline

 Odpovědět Odpovědět archiv
Autor
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Téma: Vytvoření složitější polyline
    Zasláno: 09.led.2018 v 12:30
Zdravím, potřeboval bych poradit, jak udělat složitější čáru slouženou z vícero křivek. Ušetřilo by mi to fůru času. díky 
 Tu je jak by měla vypadat. 
Připojené náhledyPřihlaste se pro zobrazení plné verze - 57656/Cesty_návrh.JPG

Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 17519
Řešení Řešení
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 10.led.2018 v 11:05
Tak nakonec to přeci jen stálo za zobecnění. Freeware utilita "toMulti" (ke stažení viz Download) převede vybrané křivky na multi-čáry (s případnými koncovými bloky) dle předefinované sady definic v tabulce v textovém souboru toMulti.tab (kdekoliv v cestě). Viz ukázkové definice v .tab souboru.
 

Připojené náhledyPřihlaste se pro zobrazení plné verze - 9/tomulti.png



Upravil Vladimír Michl - 10.led.2018 v 13:25
Zpět nahoru
zdrk Zobrazit panel
TOP uživatel
TOP uživatel

Přihlášen: 03.kvě.2007
Lokalita: ČR (KV)
Používám:
Začínám bojovat s AutoCad 2015 respektive BDS 2015
Stav: Offline
Bodů: 1734
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace zdrk Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 13:36
Co to zkusit jako dynamický blok?
Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 13:49
Jestli stačí rovný úsek, určitě dynamickým blokem. Nebo pak multičárou, ale bez oněch koncových bloků.
Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 14:08
nebude to pouze rovná čára, ideální by bylo, kdyby šla i do oblouků vimplementovat. 
Zpět nahoru
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 14:09
Dynamický blok nemůžu, protože to potřebuji na křivky
Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 14:43
V tom případě jedině programováním - odvozením nového typu objektu z objektu LWPOLYLINE (to už je trochu "vyšší dívčí").
Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 14:56
To není dobré, a když by se jednalo pouze o křivku, řešení by tedy bylo před tu Multičáru? zkoušel jsem to složil, ale odrazuje mě tam věc, že nejde nastavit tloušťka jednotlivých čar.
 Nebo je řešení takové, že to musím poskládát po desetinách milimetru čáry jedné barvy a posléze na střed v řadě za sebou umístit tu čárkovanou? 

Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 15:07
Tloušťka jde většinou nahradit výplní, popř. jde změnit globálně (jako u jiných čar).
Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
johny Zobrazit panel
TOP uživatel
TOP uživatel

Přihlášen: 24.led.2006
Lokalita: ČR (JM)
Používám:
AutoCAD Civil 3D 2016
Stav: Offline
Bodů: 1255
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace johny Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 16:28
No asi by šlo docela snadno napsat utilitku (nebo i najít), která by aplikovala specifickou sestavu na již nakreslenou polyline (jakože násobný offset + změna vlastností). Samozřejmě by to bylo jen statické, čili kdyby se změnila ta původní polyline, tak by se ostatní nezměnily...
Zpět nahoru
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 17:54
fůha, tak to je pro mě španělská vesnice se přiznám. Nemáte někde někdo náhodou nějaký návod jak se z tohodle vymotat? 
Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 18:26
Vzhledem k tomu, že to je dost specifický požadavek a případný nástroj asi nepůjde úplně zobecnit a byl by jen pro vás - je asi jen možnost poptat vývoj takové utility. Johny nebo někdo u nás by si s tím určitě poradili :-)
Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
johny Zobrazit panel
TOP uživatel
TOP uživatel

Přihlášen: 24.led.2006
Lokalita: ČR (JM)
Používám:
AutoCAD Civil 3D 2016
Stav: Offline
Bodů: 1255
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace johny Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 21:36
Návod jak napsat utilitku nebo jak hledat? Ukazuje se že není snadné něco kloudného dohledat. Napsat to není opravdu moc složité, ale chce to trochu mít základy.

Přemýšlel jsem, že bych napsal něco univerzálnějšího, ale pak jsem dal přednost to napsat jak nejjednodušeji to jde, aby jste si to mohl snadno upravit k obrazu svému. V utilitě jsou použity autocadovské příkazy, takže si to můžete v příkazovém řádku odkoukat. Jediné co je, že mám ENG autocad a neznám přesně české překlady, ale vy pokud budete něco upravovat, tak to můžete klidně přepsat na příkazy české.

Např "_.COPY" -> "KOPIE", (česky bez podtržítka a tečky)

(vl-load-com)

(defun c:SložitějšíKřivka ( / pnt enl ent ss i)

  (if (setq pnt (getpoint "\nPrvní bod nebo <vyber>: "))
    (progn
      (setq enl (entlast))
      (command-s "_.PLINE" "_none" pnt)
      (if (not (equal enl (setq enl (entlast))))
(setq ss (ssadd enl))))
    (progn
      (princ "\nVyber křivky, ")
      (setq ss (ssget "_:L" '((0 . "LWPOLYLINE"))))))

  (if ss
    (repeat (setq i (sslength ss))
      (setq ent (ssname ss (setq i (1- i))))
             
      (vla-offset (vlax-ename->vla-object ent) 0.25)
      (command "_.CHPROP" "_Last" "" "_Color" 30 ""
               "_.PEDIT"  "_Last" "_Width" 0.25 "")

      (vla-offset (vlax-ename->vla-object ent) -0.25)
      (command "_.CHPROP" "_Last" "" "_Color" 30 ""
               "_.PEDIT"  "_Last" "_Width" 0.25 "")

      (command "_.CHPROP" ent "" "_Color" 41 ""
               "_.PEDIT"  ent "_Width" 0.25 "")

      (command "_.COPY" ent "" "_Displacement" "_none" '(0 0 0)
               "_.CHPROP" "_Last" "" "_Color" 1 ""
               "_.CHPROP" "_Last" "" "_LType" "Dashed" ""
               "_.PEDIT"  "_Last" "_Width" 0.08 "")))
  (princ)
)

Utilita je LISPem, ten kód vezměte, uložte jako *.lsp někde do SupportPath, ujistěte se že ji máte i mezi SecurityPath, pak to načtěte příkazem _APPLOAD a uložte do Kufříku v dialogu appload.
Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 09.led.2018 v 22:24
Hezké, pro CZ verzi jen "Dashed" -> "Čárkovaná".

Plus bude potřeba doplnit ty bloky na začátku a na konci. Buď jako blok nebo "namalovat". Tedy např.

(command "_INSERT" "StartBlock" (vlax-curve-getPointAtParam (vlax-ename->vla-object ent) 0) "" "" "")

Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
Vladimír Michl Zobrazit panel
Moderátor
Moderátor
Avatar
CAD Studio a.s.

Přihlášen: 09.zář.2004
Lokalita: ČR (JČ)
Používám:
Dodáváme produkty Autodesk
Stav: Offline
Bodů: 17519
Řešení Řešení
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Vladimír Michl Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 10.led.2018 v 11:05
Tak nakonec to přeci jen stálo za zobecnění. Freeware utilita "toMulti" (ke stažení viz Download) převede vybrané křivky na multi-čáry (s případnými koncovými bloky) dle předefinované sady definic v tabulce v textovém souboru toMulti.tab (kdekoliv v cestě). Viz ukázkové definice v .tab souboru.
 

Připojené náhledyPřihlaste se pro zobrazení plné verze - 9/tomulti.png



Upravil Vladimír Michl - 10.led.2018 v 13:25
Vladimír Michl (moderátor)
CAD Studio a.s. - www.cadstudio.cz
(podporu najdete na helpdesk.cadstudio.cz)
Zpět nahoru
johny Zobrazit panel
TOP uživatel
TOP uživatel

Přihlášen: 24.led.2006
Lokalita: ČR (JM)
Používám:
AutoCAD Civil 3D 2016
Stav: Offline
Bodů: 1255
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace johny Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 10.led.2018 v 11:59
Původně odeslal(a) Vladimír Michl Vladimír Michl napsal(a):

Hezké, pro CZ verzi jen "Dashed" -> "Čárkovaná".
Plus bude potřeba doplnit ty bloky na začátku a na konci....

Díky -- nemyslel jsem že to úplně stojí za to --  ale vypadá to pěkně když člověk nakreslí tu polyline v libovolném tvaru a ono se to vzápětí celé prokreslí.

Bloky musí být buď ve výkrese nebo uložené ve vyhledávacích cestách.


(vl-load-com)

(defun c:SložitějšíKřivka ( / pnt enl ent ss i)

  (if (setq pnt (getpoint "\nPrvní bod nebo <vyber>: "))
    (progn
      (setq enl (entlast))
      (command-s "_.PLINE" "_none" pnt)
      (if (not (equal enl (setq enl (entlast))))
(setq ss (ssadd enl))))
    (progn
      (princ "\nVyber křivky, ")
      (setq ss (ssget "_:L" '((0 . "LWPOLYLINE"))))))

  (if ss
    (repeat (setq i (sslength ss))
      (setq ent (ssname ss (setq i (1- i))))
             
      (vla-offset (vlax-ename->vla-object ent) 0.25)
      (command "_.CHPROP" "_Last" "" "_Color" 30 ""
               "_.PEDIT"  "_Last" "_Width" 0.25 "")

      (vla-offset (vlax-ename->vla-object ent) -0.25)
      (command "_.CHPROP" "_Last" "" "_Color" 30 ""
               "_.PEDIT"  "_Last" "_Width" 0.25 "")

      (command "_.CHPROP" ent "" "_Color" 41 ""
               "_.PEDIT"  ent "_Width" 0.25 "")

      (command "_.COPY" ent "" "_Displacement" "_none" '(0 0 0)
               "_.CHPROP" "_Last" "" "_Color" 1 ""
               "_.CHPROP" "_Last" "" "_LType" "Dashed" ""
               "_.PEDIT"  "_Last" "_Width" 0.08 "")
      
      (command "._INSERT" "ArrowBlock"
               "_Scale" 1
               "_Rotate" "_none" (trans (vlax-curve-getFirstDeriv ent (vlax-curve-getParamAtPoint ent (vlax-curve-getStartPoint ent))) 0 1) "_none" (trans '(0 0 0) 0 1) 
               "_none" (trans (vlax-curve-getStartPoint ent) 0 1))

      (command "._INSERT" "ArrowBlock"
               "_Scale" 1
               "_Rotate" "_none" (trans '(0 0 0) 0 1) "_none" (trans (vlax-curve-getFirstDeriv ent (vlax-curve-getParamAtPoint ent (vlax-curve-getEndPoint ent))) 0 1)
               "_none" (trans (vlax-curve-getEndPoint ent) 0 1))))
  (princ)
)
Zpět nahoru
Fuskic Zobrazit panel
Nováček
Nováček

Přihlášen: 08.čvc.2014
Lokalita: ČR (JM)
Používám:
AutoCAD2018
Stav: Offline
Bodů: 7
Možnosti příspěvku Možnosti příspěvku   Poděkování (0) Poděkování0   Citace Fuskic Citace  OdpovědětOdpověď Přímý odkaz na tuto zprávu Zasláno: 12.led.2018 v 13:08
Mockrát Vám všem děkuji, jsem z toho nadšený a ušetří to mnoho času. 
Díky pánové! 
Zpět nahoru

Pro technickou podporu CAD
kontaktujte Helpdesk

Příbuzné CAD tipy:
Tip 8633:VIPPříkaz pro kreslení kružnice ve formě polyline.
Tip 7035:VIPPohodlné psaní textu podél libovolné křivky.
Tip 5694:VIPNevyplněné křivky - možné příčiny.
Tip 5358:Jak vytvořit osu dvou úseček?
Tip 4648:VIPJak převést MPolygony na 2D křivky se zachováním objektových dat?
Tip 2061:VIPJak rozložit SPLINE na křivku nebo úsečky?


 Odpovědět Odpovědět

Přejít na fórum Oprávnění fóra Zobrazit panel



Stránka byla vygenerována za 0,656 sekund.